package org.openxma.dsl.generator.helper;

import org.openxma.dsl.common.Strings;
import org.openxma.dsl.dom.model.Attribute;
import org.openxma.dsl.dom.model.ComplexType;
import org.openxma.dsl.dom.validation.DomDslJavaValidator;

/**
 * Xtend java extensions for general java utility functions.
 */
public class JavaUtilExtension {
	/**
	 * @param complexType
	 * @return a calculated serialVersion UID matching to the given type
	 */
	public static String serialVersionUID(ComplexType complexType) {
		Long serialVersionHash = 0L;
		for (Attribute attributeHolder : complexType.getAttributes()) {
			serialVersionHash ^= attributeHolder.getName().hashCode();
		}
		return Long.toString(serialVersionHash);
	}
	
	/**
	 * @param name
	 * @return an escaped variable name
	 */
	public static String toVariableName(String name) {
		String uncapitalize = Strings.uncapitalize(name);
		if (DomDslJavaValidator.RESERVED_KEYWORDS.contains(uncapitalize)) {
			return "_"+uncapitalize;
		}
		return uncapitalize;
	}
}
