package org.openxma.dsl.generator.impl;

import org.eclipse.emf.ecore.EObject;
import org.openxma.dsl.core.model.Model;
import org.openxma.dsl.core.model.ModelElement;
import org.openxma.dsl.dom.util.DomSwitch;
import org.openxma.dsl.generator.ModelModifier;

import com.google.common.collect.Lists;

public class AbstractDomModelModifier<T> extends DomSwitch<T> implements ModelModifier {
	private ModelModifier delegate;

	public void setDelegate(ModelModifier acceptor) {
		this.delegate = acceptor;
	}

	public ModelModifier getDelegate() {
		return delegate;
	}

	public void modifyModel(Model model) {
		if (delegate != null) {
			delegate.modifyModel(model);
		}
		doSwitch(model);
	}

	@Override
	public T defaultCase(EObject object) {
		if (object instanceof Model) {
			Model model = (Model) object;
			for (ModelElement modelElement : Lists.newArrayList(model.getElements())) {
				doSwitch(modelElement);
			}
		}
		return super.defaultCase(object);
	};

}
